package asd.td5;

import asd.base.FileDynamique;

/**
 * Une classe pour tous les exercices de feuille 5, sauf l'exercice 4.
 * @author  2002 Marc Gatano
 */
public class ArbreBinaire {

    // attributs

    private Object valeur;       // la valeur du noeud
    private ArbreBinaire gauche; // le sous-arbre gauche
    private ArbreBinaire droite; // le sous-arbre droit

    // constructeurs

    /**
     * Construit un arbre binaire vide.
     */
    public ArbreBinaire() {
        gauche = null;
        droite = null;
    }

    /**
     * Construit un arbre binaire rduit  une feuille
     * de racine x.
     */
    public ArbreBinaire(Object x) {
        valeur = x;
        gauche = new ArbreBinaire();
        droite = new ArbreBinaire();
    }

    /**
     * Construit un arbre binaire de racine x et
     * de sous-arbres gauche et droit g et d.
     */
    public ArbreBinaire(Object x, ArbreBinaire g, ArbreBinaire d) {
        valeur = x;
        gauche = g;
        droite = d;
    }

    // mthodes primitives

    /**
     * Teste si l'arbre est vide.
     */
    public boolean vide() {
        return gauche == null;
    }

    /**
     * Retourne la racine de l'arbre.
     * Prcondition : l'arbre n'est pas vide.
     */
    public Object racine() {
        return valeur;
    }

    /**
     * Retourne le sous-arbre gauche de l'arbre.
     * Prcondition : l'arbre n'est pas vide.
     */
    public ArbreBinaire gauche() {
        return gauche;
    }

    /**
     * Retourne le sous-arbre droit de l'arbre.
     * Prcondition : l'arbre n'est pas vide.
     */
    public ArbreBinaire droite() {
        return droite;
    }

    /**
     * Si l'arbre n'est pas vide, x devient la racine
     * de l'arbre. Si l'arbre est vide, l'arbre devient
     * un arbre binaire rduit  une feuille de racine x.
     */
    public void racine(Object x) {
        if ( vide() ) {
            gauche = new ArbreBinaire();
            droite = new ArbreBinaire();
        }
        valeur = x;
    }

    /**
     * Remplace le sous-arbre gauche de l'arbre par a.
     * Prcondition : l'arbre n'est pas vide.
     */
    public void gauche(ArbreBinaire a) {
        gauche = a;
    }

    /**
     * Remplace le sous-arbre droit de l'arbre par a.
     * Prcondition : l'arbre n'est pas vide.
     */
    public void droite(ArbreBinaire a) {
        droite = a;
    }

    // mthodes non primitives

    /**
     * Affiche l'arbre sous une forme lisible.
     */
    public void afficher() {
        afficher("","");
    }

    /**
     * Affiche l'arbre sous une forme lisible avec r comme prfixe
     * de la chane correspondant  la racine et p comme prfixe
     * des autres chanes.
     */
    private void afficher(String r, String p) {
        if ( vide() ) {
            System.out.println(r);
        }
        else {
            String rs = racine().toString();
            System.out.println(r + rs);
            if ( ! gauche().vide() || ! droite().vide() ) {
                String rr = p + '|' + chaine('_',rs.length()) + ' ';
                droite().afficher(rr, p + '|' + chaine(' ',rs.length() + 1));
                System.out.println(p + '|');
                gauche().afficher(rr, p + chaine(' ',rs.length() + 2));
            }
        }
    }

    /**
     * Retourne une chane de longueur k ne contenant que le
     * caractre c.
     */
    private String chaine(char c, int k) {
        String s = "";
        for ( int i = 0; i < k; i++ ) {
            s += c;
        }
        return s;
    }

    // EXO 1 : mesures

    /**
     * Retourne la taille de l'arbre.
     */
    public int taille() {
        return 0;
    }

    /**
     * Retourne la hauteur de l'arbre.
     */
    public int hauteur() {
        return -1;
    }

    /**
     * Retourne la bassesse de l'arbre.
     */
    public int bassesse() {
        return -1;
    }

    /**
     * Retourne le nombre de feuilles de l'arbre.
     */
    public int feuilles() {
        return 0;
    }

    // EXO 2 : Base

    /**
     * Retourne la base de l'arbre.
     */
    public int base() {
        return 0;
    }
        
    // EXO 3 : Gnalogie

    /**
     * Affiche tous les ascendants masculins de racine()  la
     * k-ime gnration.
     * Prcondition : k >= 1
     */
    public void ascendants(int k) {
    }

    /**
     * Affiche tous les ascendants masculins de racine() jusqu'
     * la k-ime gnration.
     * Prcondition : k >= 1
     */
    public void tousLesAscendants(int k) {
    }

    // EXO 5 : Les deux proprits

    ////////// Penche--Gauche

    /**
     * Teste si l'arbre a la proprit "penche--gauche".
     */
    public boolean pencheAGauche() {
        return false;
    }

    ////////// Equilibr

    /**
     * Teste si l'arbre a la proprit "quilibr".
     */
    public boolean equilibre() {
        return false;
    }

    // EXO 6 : poids

    /**
     * Retourne le poids de l'arbre.
     */
    public int poids() {
        return 0;
    }

    /**
     * Transforme l'arbre en un arbre quivalent de poids minimum
     * en utilisant la fonction poids prcdente.
     */
    public void minimiser1() {
    }

    /**
     * Transforme l'arbre en un arbre quivalent de poids minimum
     * et retourne le poids de l'arbre ainsi transform.
     */
    public int minimiser2() {
        return 0;
    }

    // EXO 7 : Harmonieux
    
    /**
     * Teste si l'arbre a la proprit "harmonieux".
     */
    public boolean harmonieux() {
        return false;
    }

    // EXO 8 : Parcours par niveaux

    /**
     * Affiche sur le flux de sortie tous les lments de l'arbre
     * dans l'ordre "par niveau". Ce parcours est un parcours en
     * largeur qui diffrencie les profondeurs des lments.
     */
    public void parcoursNiveau() {
    }

    // EXO 9 : Largeur

    /**
     * Calcule la largeur de l'arbre, soit le nombre maximum d'lments
     *  la mme profondeur.
     */
    public int largeur() {
        return 0;
    }

    // EXO 10 : Gnalogie (2)

    /**
     * Affiche tous les ascendants masculins de racine()  la
     * k-ime gnration.
     * Prcondition : k >= 1
     */
    public void ascendants2(int k) {
    }

    /**
     * Affiche tous les ascendants masculins de racine() jusqu'
     * la k-ime gnration.
     * Prcondition : k >= 1
     */
    public void tousLesAscendants2(int k) {
    }
}
